diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
index 85daf0176..91b920e26 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
@@ -4,242 +4,221 @@ import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.TextFieldElement;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.render.entity.EntityRenderer;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.client.gui.options.OptionsButtonElement;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.menu.MenuInventoryCreative;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.render.EntityRenderDispatcher;
+import net.minecraft.client.render.EntityRendererDispatcher;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.gui.TextFieldElement.ITextChangeListener;
-import org.lwjgl.opengl.GL12;
-
-public class ScreenInventoryCreative extends ScreenInventory implements ITextChangeListener
-{
-	protected ButtonElement lastPageButton;
-	protected ButtonElement nextPageButton;
-	protected ButtonElement clearSearchButton;
-	protected TextFieldElement searchField;
-	protected MenuInventoryCreative container;
-	protected String pageString = "1/1";
-	
-	public ScreenInventoryCreative(Player entityplayer)
-	{
-		super(entityplayer);
-		xSize = 298;
-		container = (MenuInventoryCreative)entityplayer.inventorySlots;
-		armourValuesFloat = 186;
-		armourButtonFloatX = 81;
-		overlayButtonsLayout.setOffset(-(xSize / 2), -(ySize / 2) - 10);
-	}
-	
-	@Override
-	public void init()
-	{
-		super.init();
-		buttons.add(lastPageButton = new ButtonElement(500, 0, 0, 20, 20, "<"));
-		buttons.add(nextPageButton = new ButtonElement(501, 0, 0, 20, 20, ">"));
-		buttons.add(clearSearchButton = new OptionsButtonElement(0, 0, 10, 12, 20, "").setTextures("minecraft:gui/screen/creative/clear", "minecraft:gui/screen/creative/clear_highlighted", null));
-		searchField = new TextFieldElement(this, fontRenderer, 0, 0, 96, 18, container.searchText, I18n.getInstance().translateKey("gui.inventory.creative.label.search"));
-		searchField.drawBackground =false;
-		searchField.setMaxStringLength(14);
-		searchField.setTextChangeListener(this);
-		updatePageSwitcher();
-		Keyboard.enableRepeatEvents(true);
-	}
-	
-	public void scroll(int direction) {
-		if(direction == 0) return;
-		int count = 1;
-		if(Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
-			count = 10;
-			if(Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT)) {
-				count = 100;
-			}
-		}
-		while(lastPageButton.enabled && direction > 0 && count > 0) {
-			container.lastPage();
-			updatePageSwitcher();
-			count--;
-		}
-		while(nextPageButton.enabled && direction < 0 && count > 0) {
-			container.nextPage();
-			updatePageSwitcher();
-			count--;
-		}
-	}
-
-	@Override
-	public void tick()
-	{
-		super.tick();
-		searchField.updateCursorCounter();
-	}
-
-	@Override
-	public void removed()
-	{
-		super.removed();
-		Keyboard.enableRepeatEvents(false);
-	}
-
-	protected void updatePageSwitcher()
-	{
-		lastPageButton.enabled = container.page != 0;
-		nextPageButton.enabled = container.page != container.maxPage;
-		
-		pageString = (container.page + 1) + "/" + (container.maxPage + 1);
-	}
-	
+
+public class ScreenInventoryCreative extends ScreenInventory implements ITextChangeListener {
+    protected ButtonElement lastPageButton;
+    protected ButtonElement nextPageButton;
+    protected ButtonElement clearSearchButton;
+    protected TextFieldElement searchField;
+    protected MenuInventoryCreative container;
+    protected String pageString = "1/1";
+
+    public ScreenInventoryCreative(Player entityplayer) {
+        super(entityplayer);
+        this.xSize = 298;
+        this.container = (MenuInventoryCreative) entityplayer.inventorySlots;
+        this.armourValuesFloat = 186;
+        this.armourButtonFloatX = 81;
+        this.overlayButtonsLayout.setOffset(-(this.xSize / 2), -(this.ySize / 2) - 10);
+    }
+
+    @Override
+    public void init() {
+        super.init();
+        this.buttons.add(this.lastPageButton = new ButtonElement(500, 0, 0, 20, 20, "<"));
+        this.buttons.add(this.nextPageButton = new ButtonElement(501, 0, 0, 20, 20, ">"));
+        this.buttons.add(this.clearSearchButton = new OptionsButtonElement(0, 0, 10, 12, 20, "").setTextures("minecraft:gui/screen/creative/clear", "minecraft:gui/screen/creative/clear_highlighted", null));
+        this.searchField = new TextFieldElement(this, this.fontRenderer, 0, 0, 96, 18, this.container.searchText, I18n.getInstance().translateKey("gui.inventory.creative.label.search"));
+        this.searchField.drawBackground = false;
+        this.searchField.setMaxStringLength(14);
+        this.searchField.setTextChangeListener(this);
+        updatePageSwitcher();
+        Keyboard.enableRepeatEvents(true);
+    }
+
+    public void scroll(int direction) {
+        if (direction == 0) return;
+        int count = 1;
+        if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
+            count = 10;
+            if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT)) {
+                count = 100;
+            }
+        }
+        while (this.lastPageButton.enabled && direction > 0 && count > 0) {
+            this.container.lastPage();
+            updatePageSwitcher();
+            count--;
+        }
+        while (this.nextPageButton.enabled && direction < 0 && count > 0) {
+            this.container.nextPage();
+            updatePageSwitcher();
+            count--;
+        }
+    }
+
     @Override
-	protected void buttonClicked(@NotNull ButtonElement button)
-    {
-		super.buttonClicked(button);
-    	if (!button.enabled)
-    	{
-    		return;
-    	}
-    	
-    	if (button == lastPageButton)
-    	{
-    		scroll(1);
-    	}
-    	else if (button == nextPageButton)
-    	{
-    		scroll(-1);
-    	}
-    	else if (button == clearSearchButton)
-    	{
-			if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT))
-			{
-				for(int i = 0; i < container.inventory.getContainerSize() + container.craftSlots.getContainerSize() + container.resultSlots.getContainerSize(); i++) {
-					mc.playerController.handleInventoryMouseClick(container.containerId, InventoryAction.CREATIVE_DELETE, new int[]{i}, mc.thePlayer);
-				}
-			}
-			else
-			{
-				searchField.setText("");
-				container.searchPage("");
-				updatePageSwitcher();
-			}
-    	}
-    	
-    	updatePageSwitcher();
+    public void tick() {
+        super.tick();
+        this.searchField.updateCursorCounter();
     }
 
-	@Override
-	public void render(int mx, int my, float partialTick) {
-		super.render(mx, my, partialTick);
-		searchField.updateCursor(mc, mx, my);
-	}
+    @Override
+    public void removed() {
+        super.removed();
+        Keyboard.enableRepeatEvents(false);
+    }
+
+    protected void updatePageSwitcher() {
+        this.lastPageButton.enabled = this.container.page != 0;
+        this.nextPageButton.enabled = this.container.page != this.container.maxPage;
+
+        this.pageString = (this.container.page + 1) + "/" + (this.container.maxPage + 1);
+    }
+
+    @Override
+    protected void buttonClicked(@NotNull ButtonElement button) {
+        super.buttonClicked(button);
+        if (!button.enabled) {
+            return;
+        }
+
+        if (button == this.lastPageButton) {
+            scroll(1);
+        } else if (button == this.nextPageButton) {
+            scroll(-1);
+        } else if (button == this.clearSearchButton) {
+            if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT)) {
+                for (int i = 0; i < this.container.inventory.getContainerSize() + this.container.craftSlots.getContainerSize() + this.container.resultSlots.getContainerSize(); i++) {
+                    this.mc.playerController.handleInventoryMouseClick(this.container.containerId, InventoryAction.CREATIVE_DELETE, new int[]{i}, this.mc.thePlayer);
+                }
+            } else {
+                this.searchField.setText("");
+                this.container.searchPage("");
+                updatePageSwitcher();
+            }
+        }
 
-	@Override
-	public void mouseClicked(int mx, int my, int buttonNum)
-    {
+        updatePageSwitcher();
+    }
+
+    @Override
+    public void render(int mx, int my, float partialTick) {
+        super.render(mx, my, partialTick);
+        this.searchField.updateCursor(this.mc, mx, my);
+    }
+
+    @Override
+    public void mouseClicked(int mx, int my, int buttonNum) {
         super.mouseClicked(mx, my, buttonNum);
-        searchField.mouseClicked(mx, my, buttonNum);
+        this.searchField.mouseClicked(mx, my, buttonNum);
     }
-    
+
     @Override
-	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
-    {
-    	if (searchField.isFocused && eventKey != Keyboard.KEY_ESCAPE)
-    	{
-    		searchField.textboxKeyTyped(eventCharacter, eventKey);
-    		container.searchPage(searchField.getText());
-    		updatePageSwitcher();
-    	}
-    	else if (!searchField.isFocused && eventCharacter == 't')
-    	{
-    		searchField.setFocused(true);
-    	}
-    	else
-    	{
-    		super.keyPressed(eventCharacter, eventKey, mx, my);
-    	}
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        if (this.searchField.isFocused && eventKey != Keyboard.KEY_ESCAPE) {
+            this.searchField.textboxKeyTyped(eventCharacter, eventKey);
+            this.container.searchPage(this.searchField.getText());
+            updatePageSwitcher();
+        } else if (!this.searchField.isFocused && eventCharacter == 't') {
+            this.searchField.setFocused(true);
+        } else {
+            super.keyPressed(eventCharacter, eventKey, mx, my);
+        }
     }
-    
+
     @Override
-	protected void drawGuiContainerForegroundLayer()
-    {
-    	super.drawGuiContainerForegroundLayer();
-    	drawStringCenteredNoShadow(fontRenderer, pageString, 238, 146, 0x404040);
+    protected void drawGuiContainerForegroundLayer() {
+        super.drawGuiContainerForegroundLayer();
+        drawStringCenteredNoShadow(this.fontRenderer, this.pageString, 238, 146, 0x404040);
     }
-	
+
     @Override
-	protected void drawGuiContainerBackgroundLayer(float f)
-    {
-		scroll(Mouse.getDWheel());
-
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-		mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/creative.png").bind();
-        int x = (width - xSize) / 2;
-        int y = (height - ySize) / 2;
-        lastPageButton.xPosition = x + 182;
-        lastPageButton.yPosition = y + 140;
-        nextPageButton.xPosition = x + 272;
-        nextPageButton.yPosition = y + 140;
-        clearSearchButton.xPosition = x + 280;
-        clearSearchButton.yPosition = y + 6;
-        searchField.xPosition = x + 183;
-        searchField.yPosition = y + 7;
-        drawTexturedModalRect((double)x, (double)y, 0, 0, xSize, ySize, xSize / 2, ySize / 2);
-
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
-        GL11.glEnable(GL11.GL_DEPTH_TEST);
-        GL11.glPushMatrix();
-        GL11.glTranslatef(x + 51, y + 75, 50F);
+    protected void drawGuiContainerBackgroundLayer(float f) {
+        scroll(Mouse.getDWheel());
+
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/creative.png").bind();
+        int x = (this.width - this.xSize) / 2;
+        int y = (this.height - this.ySize) / 2;
+        this.lastPageButton.xPosition = x + 182;
+        this.lastPageButton.yPosition = y + 140;
+        this.nextPageButton.xPosition = x + 272;
+        this.nextPageButton.yPosition = y + 140;
+        this.clearSearchButton.xPosition = x + 280;
+        this.clearSearchButton.yPosition = y + 6;
+        this.searchField.xPosition = x + 183;
+        this.searchField.yPosition = y + 7;
+        drawTexturedModalRect(x, (double) y, 0, 0, this.xSize, this.ySize, this.xSize / 2, this.ySize / 2);
+
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+//        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.setShader(Shaders.WORLD);
+        GLRenderer.getFogState().disable();
+        GLRenderer.modelM4f().translate(x + 51, y + 75, 50F);
         float f1 = 30F;
-        GL11.glScalef(-f1, f1, f1);
-        GL11.glRotatef(180F, 0.0F, 0.0F, 1.0F);
-        float f2 = mc.thePlayer.yBodyRot;
-        float f3 = mc.thePlayer.yRot;
-        float f4 = mc.thePlayer.xRot;
-        float f5 = (float)(x + 51) - xSize_lo;
-        float f6 = (float)((y + 75) - 50) - ySize_lo;
-        GL11.glRotatef(135F, 0.0F, 1.0F, 0.0F);
+        GLRenderer.modelM4f().scale(-f1, f1, f1);
+        GLRenderer.modelM4f().rotateZ(org.joml.Math.toRadians(180F));
+        float f2 = this.mc.thePlayer.yBodyRot;
+        float f3 = this.mc.thePlayer.yRot;
+        float f4 = this.mc.thePlayer.xRot;
+        float f5 = (float) (x + 51) - this.xSize_lo;
+        float f6 = (float) ((y + 75) - 50) - this.ySize_lo;
+        GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(135F));
         Lighting.enableLight();
-        GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(-(float)Math.atan(f6 / 40F) * 20F, 1.0F, 0.0F, 0.0F);
-        mc.thePlayer.yBodyRot = (float)Math.atan(f5 / 40F) * 20F;
-        mc.thePlayer.yRot = (float)Math.atan(f5 / 40F) * 40F;
-        mc.thePlayer.xRot = -(float)Math.atan(f6 / 40F) * 20F;
-        mc.thePlayer.entityBrightness = 1.0F;
-        GL11.glTranslatef(0.0F, mc.thePlayer.heightOffset, 0.0F);
-        EntityRenderDispatcher.instance.viewLerpYaw = 180F;
-		EntityRenderer.renderShadows = false;
-        EntityRenderDispatcher.instance.renderEntityPreviewWithPosYaw(Tessellator.instance, mc.thePlayer, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
-		EntityRenderer.renderShadows = true;
-		mc.thePlayer.entityBrightness = 0.0F;
-        mc.thePlayer.yBodyRot = f2;
-        mc.thePlayer.yRot = f3;
-        mc.thePlayer.xRot = f4;
-        GL11.glPopMatrix();
+        GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(-135F));
+        GLRenderer.modelM4f().rotateX(org.joml.Math.toRadians(-(float) Math.atan(f6 / 40F) * 20F));
+        this.mc.thePlayer.yBodyRot = (float) Math.atan(f5 / 40F) * 20F;
+        this.mc.thePlayer.yRot = (float) Math.atan(f5 / 40F) * 40F;
+        this.mc.thePlayer.xRot = -(float) Math.atan(f6 / 40F) * 20F;
+        this.mc.thePlayer.entityBrightness = 1.0F;
+        GLRenderer.modelM4f().translate(0.0F, this.mc.thePlayer.heightOffset, 0.0F);
+        EntityRendererDispatcher.instance.viewLerpYaw = 180F;
+        EntityRenderer.renderShadows = false;
+        GLRenderer.globalGetNormalTransformMatrix().scale(1, -1, 1);
+        EntityRendererDispatcher.instance.renderEntityPreviewWithPosYaw(GLRenderer.getTessellator(), this.mc.thePlayer, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
+        EntityRenderer.renderShadows = true;
+        this.mc.thePlayer.entityBrightness = 0.0F;
+        this.mc.thePlayer.yBodyRot = f2;
+        this.mc.thePlayer.yRot = f3;
+        this.mc.thePlayer.xRot = f4;
+        GLRenderer.popFrame();
         Lighting.disable();
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
-        searchField.drawTextBox();
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        this.searchField.drawTextBox();
     }
 
-	@Override
+    @Override
     public void textChanged(TextFieldElement textField) {
-		container.searchPage(textField.getText());
-		updatePageSwitcher();
-	}
-	@Override
-	public void guiSpecificControllerInput(@NotNull ControllerInput controller){
-		if(controller.buttonLeftShoulder.pressedThisFrame()) {
-			this.scroll(1);
-		}
-		if(controller.buttonRightShoulder.pressedThisFrame()) {
-			this.scroll(-1);
-		}
-		super.guiSpecificControllerInput(controller);
-	}
+        this.container.searchPage(textField.getText());
+        updatePageSwitcher();
+    }
+
+    @Override
+    public void guiSpecificControllerInput(@NotNull ControllerInput controller) {
+        if (controller.buttonLeftShoulder.pressedThisFrame()) {
+            this.scroll(1);
+        }
+        if (controller.buttonRightShoulder.pressedThisFrame()) {
+            this.scroll(-1);
+        }
+        super.guiSpecificControllerInput(controller);
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenTrommel.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenTrommel.java
index 3319ff80d..7ba7105f2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenTrommel.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenTrommel.java
@@ -1,48 +1,44 @@
 package net.minecraft.client.gui.container;
 
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.block.entity.TileEntityTrommel;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.menu.MenuTrommel;
 import org.lwjgl.opengl.GL11;
 
-public class ScreenTrommel extends ScreenContainerAbstract
-{
+public class ScreenTrommel extends ScreenContainerAbstract {
+    private final TileEntityTrommel trommelInventory;
 
-    public ScreenTrommel(ContainerInventory inventoryplayer, TileEntityTrommel tileentitytrommel)
-    {
-        super(new MenuTrommel(inventoryplayer, tileentitytrommel));
-        ySize = 192;
-        trommelInventory = tileentitytrommel;
+
+    public ScreenTrommel(ContainerInventory containerInventory, TileEntityTrommel tileentitytrommel) {
+        super(new MenuTrommel(containerInventory, tileentitytrommel));
+        this.ySize = 192;
+        this.trommelInventory = tileentitytrommel;
     }
 
     @Override
-	protected void drawGuiContainerForegroundLayer()
-    {
+    protected void drawGuiContainerForegroundLayer() {
         drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.trommel.label.trommel"), 60, 6, 0x404040);
-        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.trommel.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
+        drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.trommel.label.inventory"), 8, (this.ySize - 96) + 2, 0x404040);
     }
 
     @Override
-	protected void drawGuiContainerBackgroundLayer(float f)
-    {
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/trommel.png").bind();
-        int j = (width - xSize) / 2;
-        int k = (height - ySize) / 2;
-        drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
-        if(trommelInventory.isBurning())
-        {
-            int l = trommelInventory.getBurnTimeRemainingScaled(12);
+    protected void drawGuiContainerBackgroundLayer(float f) {
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/trommel.png").bind();
+        int j = (this.width - this.xSize) / 2;
+        int k = (this.height - this.ySize) / 2;
+        drawTexturedModalRect(j, k, 0, 0, this.xSize, this.ySize);
+        if (this.trommelInventory.isBurning()) {
+            int l = this.trommelInventory.getBurnTimeRemainingScaled(12);
             drawTexturedModalRect(j + 33, (k + 33 + 12) - l, 176, 12 - l, 14, l + 2);
         }
-        int i1 = (int)trommelInventory.getCookProgressPercent(8)%4;
-        GL11.glPushMatrix();
-        GL11.glTranslatef((j+105), (k+50), 0.0F);
-        drawTexturedModalRect(0, 0, 176+(i1*16), 16, 16, 16);
-        GL11.glPopMatrix();
+        int i1 = (int) this.trommelInventory.getCookProgressPercent(8) % 4;
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((j + 105), (k + 50), 0.0F);
+        drawTexturedModalRect(0, 0, 176 + (i1 * 16), 16, 16, 16);
+        GLRenderer.popFrame();
 
     }
-
-    private TileEntityTrommel trommelInventory;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingMinecraft.java b/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingMinecraft.java
index cd0b82495..4be4956b8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingMinecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingMinecraft.java
@@ -4,7 +4,9 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.ClickableLabelElement;
 import net.minecraft.client.gui.Screen;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.util.helper.UrlHelper;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
@@ -12,46 +14,41 @@ import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 import org.slf4j.Logger;
 
-import java.awt.*;
-import java.net.URI;
-
 public class ScreenMissingMinecraft extends Screen {
     private static final Logger LOGGER = LogUtils.getLogger();
     public int ticks = 0;
+
     @Override
-    public void init()
-    {
+    public void init() {
         I18n i = I18n.getInstance();
-        buttons.clear();
+        this.buttons.clear();
         String downloadString = i.translateKey("gui.no_minecraft.button.guide");
-        buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 120 + 12, i.translateKey("gui.no_minecraft.button.quit")));
-        ClickableLabelElement installLabel = new ClickableLabelElement(1, width / 2 - 170, (height / 4 - 60) + 60 + 64, downloadString, 0x7C99EA);
-        buttons.add(installLabel);
-        buttons.add(new ClickableLabelElement(2, 0,  height - mc.font.getFont().fontHeight() - 4, i.translateKey("gui.main_menu.button.discord"), 0x5865F2));
+        this.buttons.add(new ButtonElement(0, this.width / 2 - 100, this.height / 4 + 120 + 12, i.translateKey("gui.no_minecraft.button.quit")));
+        ClickableLabelElement installLabel = new ClickableLabelElement(1, this.width / 2 - 170, (this.height / 4 - 60) + 60 + 64, downloadString, 0x7C99EA);
+        this.buttons.add(installLabel);
+        this.buttons.add(new ClickableLabelElement(2, 0, this.height - this.mc.font.getFont().fontHeight() - 4, i.translateKey("gui.main_menu.button.discord"), 0x5865F2));
     }
+
     @Override
-    public void render(int mx, int my, float partialTick)
-    {
+    public void render(int mx, int my, float partialTick) {
         I18n i = I18n.getInstance();
         drawBackground(partialTick);
-        drawStringCenteredShadow(fontRenderer, i.translateKey("gui.no_minecraft.label.title"), width / 2, (height / 4 - 60) + 20, 0xffff60);
-        drawStringShadow(fontRenderer, i.translateKey("gui.no_minecraft.label.body.1"), width / 2 - 170, (height / 4 - 60) + 60 + 0, 0xdedede);
-        drawStringShadow(fontRenderer, i.translateKey("gui.no_minecraft.label.body.2"), width / 2 - 170, (height / 4 - 60) + 60 + 18, 0xdedede);
-        drawStringShadow(fontRenderer, i.translateKey("gui.no_minecraft.label.body.3"), width / 2 - 170, (height / 4 - 60) + 60 + 27, 0xdedede);
-        drawStringShadow(fontRenderer, i.translateKey("gui.no_minecraft.label.body.4"), width / 2 - 170, (height / 4 - 60) + 60 + 45, 0xdedede);
-        drawStringShadow(fontRenderer, i.translateKey("gui.no_minecraft.label.body.5"), width / 2 - 170, (height / 4 - 60) + 60 + 54, 0xdedede);
+        drawStringCenteredShadow(this.fontRenderer, i.translateKey("gui.no_minecraft.label.title"), this.width / 2, (this.height / 4 - 60) + 20, 0xffff60);
+        drawStringShadow(this.fontRenderer, i.translateKey("gui.no_minecraft.label.body.1"), this.width / 2 - 170, (this.height / 4 - 60) + 60, 0xdedede);
+        drawStringShadow(this.fontRenderer, i.translateKey("gui.no_minecraft.label.body.2"), this.width / 2 - 170, (this.height / 4 - 60) + 60 + 18, 0xdedede);
+        drawStringShadow(this.fontRenderer, i.translateKey("gui.no_minecraft.label.body.3"), this.width / 2 - 170, (this.height / 4 - 60) + 60 + 27, 0xdedede);
+        drawStringShadow(this.fontRenderer, i.translateKey("gui.no_minecraft.label.body.4"), this.width / 2 - 170, (this.height / 4 - 60) + 60 + 45, 0xdedede);
+        drawStringShadow(this.fontRenderer, i.translateKey("gui.no_minecraft.label.body.5"), this.width / 2 - 170, (this.height / 4 - 60) + 60 + 54, 0xdedede);
         super.render(mx, my, partialTick);
     }
+
     @Override
-    protected void buttonClicked(@NotNull ButtonElement button)
-    {
-        if(!button.enabled)
-        {
+    protected void buttonClicked(@NotNull ButtonElement button) {
+        if (!button.enabled) {
             return;
         }
-        if(button.id == 0)
-        {
-            mc.shutdown();
+        if (button.id == 0) {
+            this.mc.shutdown();
         }
         if (button.id == 1) {
             UrlHelper.openURL("https://www.betterthanadventure.net/installation-guide/");
@@ -59,44 +56,44 @@ public class ScreenMissingMinecraft extends Screen {
             UrlHelper.openURL("https://betterthanadventure.net/discord");
         }
     }
+
     @Override
-    public void tick(){
-        ticks += 30;
+    public void tick() {
+        this.ticks += 30;
     }
 
-    public void drawBackground(float partialTick)
-    {
-        GL11.glDisable(GL11.GL_LIGHTING);
+    public void drawBackground(float partialTick) {
+        GLRenderer.globalSetLightEnabled(false);
         GL11.glDisable(GL11.GL_FOG);
 
-        Tessellator tessellator = Tessellator.instance;
-        mc.textureManager.loadTexture("/assets/minecraft/textures/block/cobbled_netherrack_mossy.png").bind();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glEnable(GL11.GL_BLEND);
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        this.mc.textureManager.loadTexture("/assets/minecraft/textures/block/cobbled_netherrack_mossy.png").bind();
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.enableState(State.BLEND);
 
         // Draw mossy netherrack first
         float f = 32F;
         tessellator.startDrawingQuads();
-        tessellator.setColorOpaque_I(0x404040);
-        tessellator.addVertexWithUV(0.0D, height, 0.0D, 0.0D, (float)height / f);
-        tessellator.addVertexWithUV(width, height, 0.0D, (float)width / f, (float)height / f);
-        tessellator.addVertexWithUV(width, 0.0D, 0.0D, (float)width / f, 0);
+        tessellator.setColorOpaque1i(0x404040);
+        tessellator.addVertexWithUV(0.0D, this.height, 0.0D, 0.0D, (float) this.height / f);
+        tessellator.addVertexWithUV(this.width, this.height, 0.0D, (float) this.width / f, (float) this.height / f);
+        tessellator.addVertexWithUV(this.width, 0.0D, 0.0D, (float) this.width / f, 0);
         tessellator.addVertexWithUV(0.0D, 0.0D, 0.0D, 0.0D, 0);
         tessellator.draw();
 
-        mc.textureManager.loadTexture("/assets/minecraft/textures/block/dirt.png").bind();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0f);
+        this.mc.textureManager.loadTexture("/assets/minecraft/textures/block/dirt.png").bind();
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0f);
 
         // Then Draw dirt texture
         tessellator.startDrawingQuads();
-        tessellator.setColorRGBA_F(64/255f, 64/255f, 64/255f, MathHelper.clamp(1f - ((float)ticks + partialTick)/80000f, 0f, 1f)); // Fade from dirt texture to mossy netherrack in the span of 66.6 minutes :)
-        tessellator.addVertexWithUV(0.0D, height, 0.0D, 0.0D, (float)height / f);
-        tessellator.addVertexWithUV(width, height, 0.0D, (float)width / f, (float)height / f);
-        tessellator.addVertexWithUV(width, 0.0D, 0.0D, (float)width / f, 0);
+        tessellator.setColor4f(64 / 255f, 64 / 255f, 64 / 255f, MathHelper.clamp(1f - ((float) this.ticks + partialTick) / 80000f, 0f, 1f)); // Fade from dirt texture to mossy netherrack in the span of 66.6 minutes :)
+        tessellator.addVertexWithUV(0.0D, this.height, 0.0D, 0.0D, (float) this.height / f);
+        tessellator.addVertexWithUV(this.width, this.height, 0.0D, (float) this.width / f, (float) this.height / f);
+        tessellator.addVertexWithUV(this.width, 0.0D, 0.0D, (float) this.width / f, 0);
         tessellator.addVertexWithUV(0.0D, 0.0D, 0.0D, 0.0D, 0);
         tessellator.draw();
 
         // Then gradient
-        drawGradientRect(0, 0, width, height, 0x22402020, 0xff501010);
+        drawGradientRect(0, 0, this.width, this.height, 0x22402020, 0xff501010);
     }
 }
